package quotes.local;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import quotes.Channel;
import quotes.ChannelC;
import quotes.Subscriber;

/**
 * @author delpiano
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class LocalChannel implements Channel, ChannelC {

	private List subscribers;
	private String name;
	
	/** A very simple, local, implementation of the Channel interface.
	 * @param name the name of the topic of the channel.
	 */
	public LocalChannel(String name) {
		super();
		this.name = name;
		subscribers = new LinkedList();
	}

	/**
	 * @see quotes.Channel#publish(Object, Object)
	 */
	public void publish(Object source, Object message) {
		for (Iterator it = subscribers.iterator() ; it.hasNext() ;) {
			((Subscriber) it.next()).receiveMessage(this , source , message);
		}
	}

	/**
	 * @see quotes.ChannelC#getName()
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see quotes.ChannelC#setName(String)
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @see quotes.ChannelC#addSubscriber(Subscriber)
	 */
	public void addSubscriber(Subscriber subscriber) {
		subscribers.add(subscriber);
	}

	/**
	 * @see quotes.ChannelC#removeSubscriber(Subscriber)
	 */
	public void removeSubscriber(Subscriber subscriber) {
		subscribers.remove(subscriber);
	}

	/**
	 * @see quotes.ChannelC#getSubscribers()
	 */
	public List getSubscribers() {
		return new LinkedList(subscribers);
	}
	
	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() { return name; }

}
