package quotes.local;

import quotes.Channel;

/**
 * @author delpiano
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class RandomPeriodicPublisher extends Publisher implements Runnable {

	private int period;
	private float previous_quote;


	/** A publisher that sends periodic quotations on a given <code>Channel</code>, with a default initial quotation.
	 * @param period the period of emission.
	 */
	public RandomPeriodicPublisher(int period) { this(period , 5); }

	/** A publisher that sends periodic quotations on a given <code>Channel</code>, with a given initial quotation.
	 * @param period the period of emission.
	 * @param initial_value the intial value of the quote.
	 */
	public RandomPeriodicPublisher(int period, float initial_value) {	
		super();
		this.period = period;
		this.previous_quote = initial_value;
		new Thread(this).start();	
	}

	/**
	 * @see java.lang.Runnable#run()
	 */	
	public void run() {	
		for (; ;) {
            
	 		try {
	    		Thread.sleep(period);
	 		} catch (InterruptedException _e) {
	    		break;
	 		}
            
	    	previous_quote += (previous_quote) * (2 * Math.random() - 1) * 0.1;
	    	
	    	Channel chnnl = getChannel();
	    	if (chnnl != null) {
	    		chnnl.publish(this , new Double(previous_quote));
	    	}
	    	
		}
	}
}
